<template>
  <div class="tree-view">
    <div
      :class="[
        'tree-view__caption',
        items[childrenField] ? 'tree-view__caption--root' : '',
        expanded ? 'tree-view__caption--open' : '',
      ]"
    >
      <div
        :class="[
          'tree-view__caption-content',
          showUnits && !items[childrenField]
            ? 'tree-view__caption-content--unit'
            : '',
        ]"
        :style="{ 'padding-left': `${depth * 77}px` }"
      >
        <i
          v-if="items[childrenField]"
          class="icon chevron-right"
          @click="expanded = !expanded"
        >
        </i>
        <template v-if="hasCheckbox">
          <ob-checkbox
            :value="hasChildren ? allDescendantLeafsSelected : items"
            :modelValue="hasChildren ? allDescendantLeafsSelected : value"
            :label="caption"
            :indeterminate="indeterminate"
            :disabled="isCheckboxesDisabled"
            @change="onCheckboxChange"
          />
          <span v-if="!items[childrenField] && showUnits"> {{ unit }} </span>
          <div
            class="tree-view__counter"
            v-if="showSelectedCounter && items[childrenField]"
          >
            {{ selectionCount }}/{{ allDescendantLeafs.length }}
          </div>
        </template>
        <template v-else>
          {{ caption }}
          <span v-if="!items[childrenField] && showUnits"> {{ unit }} </span>
        </template>
      </div>
    </div>
    <template v-if="expanded">
      <tree-view
        v-for="item in items[childrenField]"
        :key="item[counterUniqueField]"
        :items="item"
        :value="value"
        :hasCheckbox="hasCheckbox"
        :showSelectedCounter="showSelectedCounter"
        :captionField="captionField"
        :childrenField="childrenField"
        :unitField="unitField"
        :showUnits="showUnits"
        :depth="depth + 1"
        :isCheckboxesDisabled="isCheckboxesDisabled"
        @input="(selection) => $emit('input', selection)"
      />
    </template>
  </div>
</template>

<script>
import ObCheckbox from "./checkbox";

export default {
  name: "tree-view",

  inheritAttrs: false,

  components: {
    ObCheckbox
  },

  props: {
    hasCheckbox: {
      type: Boolean,
      default: false,
    },

    isCheckboxesDisabled: {
      type: Boolean,
      default: false,
    },

    captionField: {
      type: String,
      default: "title",
    },

    childrenField: {
      type: String,
      default: "children",
    },

    unitField: {
      type: String,
    },

    showUnits: {
      type: Boolean,
      default: false,
    },

    items: {
      type: [Object, Array, Function],
      required: true,
    },

    value: {
      type: Array,
      default: () => [],
    },

    depth: {
      type: Number,
      default: 0,
    },

    showSelectedCounter: {
      type: Boolean,
      default: false,
    },

    counterUniqueField: {
      type: String,
      default: "uuid",
    },
  },

  computed: {
    caption() {
      return this.items[this.captionField];
    },

    unit() {
      return this.items[this.unitField];
    },

    hasChildren() {
      return (
        !!this.items[this.childrenField] &&
        this.items[this.childrenField].length > 0
      );
    },

    allDescendantLeafsSelected() {
      return (
        this.hasChildren &&
        this.hasSelection &&
        this.allDescendantLeafs.every((leaf) =>
          this.value.some((sel) => sel.serviceUuid === leaf.serviceUuid)
        )
      );
    },

    allDescendantLeafs() {
      const leafs = [];
      const searchTree = (items) => {
        if (
          !!items[this.childrenField] &&
          items[this.childrenField].length > 0
        ) {
          items[this.childrenField].forEach((item) => searchTree(item));
        } else {
          leafs.push(items);
        }
      };

      searchTree(this.items);
      return leafs;
    },

    indeterminate() {
      return (
        this.hasSelection &&
        this.hasChildren &&
        this.someDescendantLeafsSelected &&
        !this.allDescendantLeafsSelected
      );
    },

    hasSelection() {
      return !!this.value && this.value.length > 0;
    },

    someDescendantLeafsSelected() {
      return (
        this.hasSelection &&
        this.allDescendantLeafs.some((leaf) =>
          this.value.some((sel) => sel.serviceUuid === leaf.serviceUuid)
        )
      );
    },

    selectionCount() {
      const i = this.allDescendantLeafs.filter(
        (leaf) =>
          !this.value.find(
            (item) =>
              leaf[this.counterUniqueField] === item[this.counterUniqueField]
          )
      );

      return this.allDescendantLeafs.length - i.length;
    },
  },

  data() {
    return {
      expanded: false,
    };
  },

  methods: {
    onCheckboxChange($event) {
      let data = [...this.value];
      if (this.hasChildren) {
        if (this.allDescendantLeafsSelected) {
          this.allDescendantLeafs.forEach((leaf) => {
            data = data.filter(item => item.serviceUuid !== leaf.serviceUuid);
          });
        } else {
          this.allDescendantLeafs.forEach((leaf) => {
            if (!this.value.some(item => item.serviceUuid === leaf.serviceUuid)) {
              data.push(leaf);
            }
          });
        }
        this.$emit("input", data);
      } else {
        this.$emit("input", $event);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.tree-view__caption {
  padding-left: 60px;
  display: flex;
  align-items: center;
  height: 31px;
  font-size: 14px;
  line-height: 20px;
  letter-spacing: 0.2px;
  color: #191e32;
  background-color: #fff;
  border-bottom: 1px solid #e5edf9;

  i {
    transition: transform 0.2s ease-in-out;
    cursor: pointer;
  }

  &--root {
    height: 40px;
    background-color: #f2f7fd;
    border-bottom: 1px solid #d6e2f6;
    border-top: 1px solid #fff;

    // .tree-view__caption-content {
    //   width: 100%;
    //   justify-content: flex-start;
    // }

    i {
      margin-right: 21px;
      font-size: 22px;
      color: #004bc8;
    }
  }

  &--open {
    i {
      transform: rotate(90deg);
    }
  }
}

.tree-view__caption-content {
  width: 100%;
  display: flex;
  align-items: center;
  flex-grow: 1;

  &--unit {
    width: 600px;
    justify-content: space-between;
  }
}

.tree-view__counter {
  margin-left: auto;
  margin-right: 20px;
  @include font-mixin(14px, 20px, 400, $color-blue-navy-blue, 0.2px);
}
</style>
